*
* getstuffed.s 
* 
* (c) jonathan hudson 1994
*

hk.gtbuf        equ     $30

sms.uthg        equ     $28
sms.fthg        equ     $29
sms.info        equ      $0
sys_thgl        equ     $b8

th_thing        equ     $10

thh_type        equ     $04
thh_entr        equ     $08
err.nimp        equ     -19
qa.resri        equ     $11a
bv_rip          equ     $58
sb.inipr        equ     $110

        section stuff

*   use hotkey system, but be quick .....
*
        lea     table(pc),a1
        move.w  sb.inipr,a2
        jsr     (a2)
        rts

* You must understand the haven comments below in the context of
* ill-educated commentators on the BBC world service (or maybe it was
* Mr Major) going on about safe havens for Kurds.

table:
        dc.w    0
        dc.w    0
        dc.w    3			; 2 really, but keep the byte
        dc.w    hk_getbf-*		; count up
        dc.b    11,'GET_STUFFED'
        dc.w    hk_getbf-*		; count up
        dc.b    12,'GET_STUFFED$'
        dc.w    0

hk_getbf:
        bsr.s    hk_use                 ; get hotkey system
        bne.s    hks_done               ; failed ...
        move.l   hk.gtbuf(a3),a4        ; our vector
        moveq    #0,d0                  ; item
        jsr      (a4)   
        move.l  a1,a3                   ; data address       
        move.w  d2,d7                   ; size
        addq.w  #3,d2                   ; get even + 2
        bclr    #0,d2                   ; clear all out etc
        moveq   #0,d1
        move.l  d2,d1

        move.l  d1,d6                   ; save haven (and tautology)
        move.w  qa.resri,a2             ; (if its a haven then it MUST be safe)
        jsr     (a2)                    ; (safety is a property of a haven)
        move.l  bv_rip(a6),a1
        sub.l   d6,a1
        move.l  a1,bv_rip(a6)       
        move.l  a1,a4
        move.w  d7,(a6,a4.l)            ; word count
        move.w  d7,d1                   ; ditto
        addq.l  #2,a4
        bra.s   h2
h1:     move.b  (a3)+,(a6,a4.l)
        addq.l  #1,a4
h2:     dbra    d1,h1
        moveq   #1,d4                   ; set up return
        moveq   #sms.fthg,d0
        moveq   #-1,d1
        lea.l   hk_thing,a0
        jsr     (a5)
hks_done:
        rts

hk_use:
        bsr.s   getthg
        bne.s   fail
        move.l  a0,a5
        moveq   #sms.uthg,d0
        moveq   #-1,d1
        moveq   #127,d3
        lea.l   hk_thing,a0
        jsr     (a5)
        move.l  a1,a3
fail:
        tst.l   d0
        rts
*
* free the hotkey system
*

getthg:
        moveq   #sms.info,d0            ; get system variables
        trap    #1
        move.l  sys_thgl(a0),d2         ; this is the thing list
        beq.s   thg_nf                  ; empty list, very bad!
        move.l  d2,a0
thg_lp:
        move.l  (a0),d2                 ; get next list entry
        beq.s   thg_found               ; end of list? here should be thing!
        move.l  d2,a0                   ; next link
        bra.s   thg_lp
thg_found:
        move.l  th_thing(a0),a0         ; get start of thing
        move.l  thh_type(a0),d2         ; is it our special thing?
        addq.l  #1,d2
        bne.s   thg_nf                  ; sorry, it isnt
        move.l  thh_entr(a0),a0         ; this is the vector we look for
        bra.s   thg_rts
thg_nf:
        moveq   #err.nimp,d0            ; no thing
thg_rts:
        tst.l   d0
        rts

hk_thing:
        dc.w    6
        dc.b    'hotkey'

        end
